<app-marketing-frame>
  <div class="account-column__inner account-column__inner--right">
    <div class="account-column__right-heading">
      <h1 class="heading-medium">Sign&nbsp;Up</h1>
      <div class="account-column__link">
        <app-text-link
          caret="right"
          id="btn-signup"
          [link]="['/account/login']"
          (click)="toggleDisplay()"
        >
          Already&nbsp;registered? Log&nbsp;in
        </app-text-link>
      </div>
    </div>

    <form novalidate [ngrxFormState]="form" (submit)="submit()">
      <app-non-field-messages
        *ngIf="errorMessage"
        [messages]="[errorMessage]"
      ></app-non-field-messages>

      <div class="form-field form-field--large">
        <app-form-label
          [for]="form.controls.email.id"
          [isLarge]="true"
          [isComplete]="stageValue !== stages.Email"
        >
          Email
        </app-form-label>

        <div
          [class.register-step__verified-input]="stageValue !== stages.Email"
        >
          <input
            type="email"
            [ngrxFormControlState]="form.controls.email"
            autofocus
            class="form-field__input"
            [disabled]="stageValue !== stages.Email"
            [class.form-field__input--invalid]="
              (form.errors._email || isEmailTaken) && form.isSubmitted
            "
            [class.form-field__input--valid]="
              !form.errors._email && !isEmailTaken
            "
            [class.register-step__verified-content]="
              stageValue !== stages.Email
            "
          />
          <a
            link="javascript:void(0)"
            (click)="switchCurrentStage(stages.Email)"
            class="register-step__verified-content--edit"
            *ngIf="stageValue === stages.Password"
            >(edit)</a
          >
        </div>

        <div *ngIf="stageValue === stages.Email">
          <div
            class="register-step__feedback register-step__feedback--fixed-height"
          >
            <span
              [class.register-step__feedback__element--active]="
                !form.isSubmitted && !form.controls.email.isValid
              "
              class="register-step__feedback__element"
            >
              Your email address is your unique username. <br />
              We don’t share it with others.
            </span>
            <span
              [class.register-step__feedback__element--active]="
                form.controls.email.isValid && !isEmailTaken
              "
              class="register-step__feedback__element"
            >
              Looks good to us! Make sure it’s correct, then press
              &ldquo;Next&rdquo; to go to the next step.
            </span>
            <ul
              *ngIf="
                form.isSubmitted &&
                (!form.controls.email.isValid || isEmailTaken)
              "
              class="form-field__error-list register-step__error-list"
            >
              <li *ngIf="isEmailTaken" class="form-field__error">
                There is already an account registered with this email address.
                <app-text-link (click)="goToLoginWith()" caret="right">
                  Log in?
                </app-text-link>
              </li>
              <li
                *ngIf="form.errors._email && form.isSubmitted"
                class="form-field__error"
              >
                Enter a valid email address.
              </li>
            </ul>
          </div>

          <div class="register-step__actions">
            <button id="email-button" class="button button--primary">
              Next
            </button>

            <progress-indicator
              [inProgress]="hasSubmitStarted"
              inProgressText="Verifying"
              [completed]="hasSubmitFinished"
              completedText=""
            ></progress-indicator>
          </div>
        </div>
      </div>
      <div class="form-field form-field--large">
        <app-form-label
          [for]="form.controls.password.id"
          [isLarge]="true"
          [isInactive]="stageValue !== stages.Password && form.errors._password"
          [isComplete]="
            stageValue !== stages.Password && !form.errors._password
          "
        >
          Password
        </app-form-label>

        <div class="form-field form-field--large">
          <div
            *ngIf="stageValue !== stages.Email"
            class="form-field__input-with-actions"
            [class.register-step__verified-input]="
              stageValue !== stages.Password
            "
          >
            <input
              #passwordInput
              [type]="form.value.showConfirm ? 'password' : 'text'"
              [ngrxFormControlState]="form.controls.password"
              autocomplete="off"
              class="form-field__input form-field__input--one-action"
              [class.form-field__input--invalid]="
                (form.errors._password && !form.errors._password?.minLength) ||
                (form.errors._password && form.isSubmitted)
              "
              [class.form-field__input--valid]="!form.errors._password"
              [class.register-step__verified-content]="
                stageValue !== stages.Password
              "
              [disabled]="stageValue !== stages.Password"
            />

            <div
              *ngIf="stageValue === stages.Password"
              class="form-field__actions"
            >
              <button
                type="button"
                tabindex="-1"
                (click)="toggleShowConfirm.emit()"
                class="form-field__action"
              >
                <div
                  id="eye-icon"
                  class="button__icon button__icon--no-text"
                  [inlineSVG]="
                    form.value.showConfirm
                      ? '../assets/svg/eye.svg'
                      : '../assets/svg/eye-slash.svg'
                  "
                ></div>
              </button>
            </div>
          </div>

          <div *ngIf="stageValue == stages.Password">
            <div class="register-step__feedback">
              <ul
                *ngIf="form.controls.password.isInvalid && form.isSubmitted"
                class="form-field__error-list register-step__error-list"
              >
                <li
                  *ngIf="form.errors._password.required"
                  class="form-field__error"
                >
                  Enter a password for your account.
                </li>
              </ul>
              <div
                *ngIf="form.errors._password?.minLength"
                class="register-step__feedback__static-element"
              >
                Make a <strong>long</strong> password.
                <span
                  *ngIf="
                    form.errors._password?.minLength &&
                    form.value.password.length < 1
                  "
                >
                  We require at least 10 characters.
                </span>
                <span
                  *ngIf="
                    form.errors._password?.minLength &&
                    form.value.password.length >= 1
                  "
                >
                  Enter at least
                  {{
                    form.errors._password.minLength.minLength -
                      form.value.password.length
                  }}
                  more character<span
                    *ngIf="
                      form.errors._password.minLength.minLength -
                        form.value.password.length !==
                      1
                    "
                    >s</span
                  >.
                </span>
              </div>

              <ul
                *ngIf="
                  form.controls.password.isInvalid &&
                  form.value.password.length >= 10
                "
                class="form-field__error-list register-step__error-list"
              >
                <li
                  *ngIf="form.errors._password.hasUniqueChars"
                  class="form-field__error"
                >
                  Password must have more than 5 unique characters.
                </li>
                <li
                  *ngIf="form.errors._password.notNumeric"
                  class="form-field__error"
                >
                  Password must not be only numbers.
                </li>
                <li
                  *ngIf="form.errors._password.notEqualTo"
                  class="form-field__error"
                >
                  Password must not be email address.
                </li>
              </ul>
              <div
                *ngIf="form.errors._password"
                class="register-step__feedback__static-element"
              >
                A good password is also <strong>unique</strong>,
                <strong>memorable</strong>, and <strong>impersonal</strong>.
                <app-text-link
                  caret="right"
                  target="_blank"
                  isExternal="true"
                  link="https://passit.io/blog/picking-a-good-password/"
                  >Learn more</app-text-link
                >
              </div>
              <div
                *ngIf="
                  !form.errors._password &&
                  !form.value.passwordConfirm &&
                  form.value.showConfirm
                "
                class="register-step__feedback__static-element"
              >
                Good! Now click the eye icon or retype your password below to
                confirm what you entered.
              </div>
              <div
                *ngIf="!form.errors._password && !form.value.showConfirm"
                class="form-field__note u-margin-b-20"
              >
                Make sure this is what you want, then press &ldquo;Next&rdquo;
                to&nbsp;continue.
              </div>
            </div>
          </div>
        </div>

        <div *ngIf="stageValue == stages.Password">
          <div
            class="form-field form-field--large"
            *ngIf="form.value.showConfirm"
          >
            <app-form-label
              [for]="form.controls.passwordConfirm.id"
              [isLarge]="true"
            >
              Confirm Password
            </app-form-label>
            <input
              type="password"
              [ngrxFormControlState]="form.controls.passwordConfirm"
              class="form-field__input"
              [class.form-field__input--invalid]="
                form.errors._passwordConfirm && form.isSubmitted
              "
              [class.form-field__input--valid]="!form.errors._passwordConfirm"
            />
            <div class="register-step__feedback">
              <div
                *ngIf="!form.errors._passwordConfirm && form.value.showConfirm"
                class="form-field__note"
              >
                That’s a match! Press &ldquo;Next&rdquo; to continue.
              </div>
              <ul
                *ngIf="
                  form.errors._passwordConfirm &&
                  form.value.showConfirm &&
                  (form.value.passwordConfirm.length >=
                    form.value.password.length ||
                    form.isSubmitted)
                "
                class="form-field__error-list register-step__error-list"
              >
                <li
                  *ngIf="form.errors._passwordConfirm.equalTo"
                  class="form-field__error"
                >
                  Passwords do not match.
                </li>
              </ul>
            </div>
          </div>

          <div class="register-step__actions">
            <progress-indicator
              [inProgress]="hasSubmitStarted"
              inProgressText=""
              [completed]="hasSubmitFinished"
              completedText=""
            ></progress-indicator>
          </div>

          <div
            class="register-step__feedback"
            [@flyInOut]="true"
            *ngIf="hasSubmitStarted"
          >
            Passit is creating your account. This can take a little time, so
            don’t navigate away.
          </div>

          <button id="password-button" class="button button--primary">
            Next
          </button>
        </div>
      </div>

      <div class="form-field form-field--large">
        <app-form-label
          [isLarge]="true"
          [isInactive]="
            stageValue !== stages.BackupCode && stageValue < stages.BackupCode
          "
          [isComplete]="
            stageValue !== stages.BackupCode && stageValue > stages.BackupCode
          "
        >
          Backup Code
        </app-form-label>

        <div
          *ngIf="
            stageValue !== stages.BackupCode && stageValue > stages.BackupCode
          "
          class="register-step__verified-content"
        >
          {{ backupCodeDownloaded ? "Downloaded" : "Skipped" }}
        </div>
      </div>

      <app-backup-code
        *ngIf="stageValue === stages.BackupCode"
        [code]="backupCode"
        (outcome)="backupCodeOutcome($event)"
        (goToNext)="incrementStage.emit()"
      >
      </app-backup-code>

      <div
        class="form-field form-field--large"
        [class.form-field--no-bottom-margin]="
          stageValue === stages.ConfirmEmail
        "
      >
        <app-form-label
          [isLarge]="true"
          [isInactive]="
            stageValue !== stages.ConfirmEmail &&
            stageValue < stages.ConfirmEmail
          "
          [isComplete]="stageValue === stages.Verified"
        >
          Verify Email Address
        </app-form-label>

        <div
          *ngIf="stageValue === stages.Verified"
          class="register-step__verified-content"
        >
          Verified
        </div>
      </div>

      <confirm-email-container
        *ngIf="stageValue === stages.ConfirmEmail"
        inline="true"
      ></confirm-email-container>

      <div
        *ngIf="stageValue === stages.Verified"
        class="register-step__heading--verified form-field form-field--large"
      >
        You're ready to start securing your passwords!
      </div>

      <div class="auth-form__actions">
        <button
          class="register-form__submit button button--large button--green"
          [disabled]="stageValue !== stages.Verified"
        >
          Get Started
        </button>
      </div>
    </form>

    <form novalidate [ngrxFormState]="urlForm" (submit)="urlSubmit()">
      <div *ngIf="isExtension">
        <div>
          <p class="register-form__paragraph">
            You are signing up for Passit at
            <app-text-link
              id="btn-signup"
              link="https://{{ urlDisplayName }}"
              [isExternal]="true"
              target="_blank"
              >{{ urlDisplayName }}</app-text-link
            >. Access the website when you're on the go.
          </p>
          <p class="register-form__paragraph register-form__paragraph--small">
            If you're signing up with your company or if you're self-hosting,
            you can
            <app-text-link
              id="btn-signup"
              (click)="displayUrl()"
              href="javascript:void(0)"
              >change the server you connect to</app-text-link
            >.
          </p>
        </div>
        <div *ngIf="showUrl">
          <div class="form-field form-field--large">
            <label [for]="urlForm.controls.url.id" class="form-field__label"
              >Server</label
            >
            <input
              type="url"
              placeholder="app.passit.io"
              [ngrxFormControlState]="urlForm.controls.url"
              class="form-field__input"
              [class.form-field__input--invalid]="
                isUrlValid === false && urlForm.isSubmitted
              "
            />
            <div class="form-field__note">
              <div
                class="form-field__error"
                *ngIf="isUrlValid === false && urlForm.isSubmitted"
              >
                The URL you entered is not a valid Passit server.
              </div>
              Enter an alternate server URL here. For example,
              passit.mycompany.com.
            </div>
          </div>
          <button type="submit" class="button button--primary">
            Change Server
          </button>
          <button
            type="button"
            class="register-form__change-server-cancel button button--text"
            (click)="hideUrl()"
          >
            Cancel
          </button>
        </div>
      </div>
    </form>
  </div>
</app-marketing-frame>
